
-- (C)Chilean Challenge v1.0
-- Carlos Valderas & Valentina Bonilla, 2010
-- Licence: ZLIB

----------------
--Botn de jugar

Boton_jugar = {}
Boton_jugar.__index = Boton_jugar

function Boton_jugar.crear(x,y)

	local temp = {}
	setmetatable(temp, Boton_jugar)
	temp.sobre = false
	temp.width = 307
	temp.height = 97
	temp.x = x
	temp.y = y
	temp.imagen = imagenes["boton_jugar_img"]
	return temp
end

function Boton_jugar:draw()

	love.graphics.draw(self.imagen, self.x, self.y)

	if self.sobre then self.imagen = imagenes["boton_jugar_imgB"]
	else self.imagen = imagenes["boton_jugar_img"]
	end
end

function Boton_jugar:update(dt)

	self.sobre = false

	local x = love.mouse.getX()
	local y = love.mouse.getY()

	if x > self.x
		and x < self.x + self.width
		and y > self.y
		and y < self.y + self.height then
		self.sobre = true
	end
end

function  Boton_jugar:mousereleased(x, y, button)
	if self.sobre then
	return true
	end
	return false
end

--Botn de Instrucciones

Boton_instrucciones = {}
Boton_instrucciones.__index = Boton_instrucciones

function Boton_instrucciones.crear(x,y)

	local temp = {}
	setmetatable(temp, Boton_instrucciones)
	temp.sobre = false
	temp.width = 307
	temp.height = 97
	temp.x = x
	temp.y = y
	temp.imagen = imagenes["boton_instrucciones_img"]
	return temp
end

function Boton_instrucciones:draw()

	love.graphics.draw(self.imagen, self.x, self.y)
	if self.sobre then self.imagen = imagenes["boton_instrucciones_imgB"]
	else self.imagen = imagenes["boton_instrucciones_img"]
	end
end

function Boton_instrucciones:update(dt)

	self.sobre = false

	local x = love.mouse.getX()
	local y = love.mouse.getY()

	if x > self.x
		and x < self.x + self.width
		and y > self.y
		and y < self.y + self.height then
		self.sobre = true
	end
end

function  Boton_instrucciones:mousereleased(x, y, button)
	if self.sobre then
	return true
	end
	return false
end

--Botn de alternativa de juego

Boton_alt = {}
Boton_alt.__index = Boton_alt

function Boton_alt.crear(x,y)

	local temp = {}
	setmetatable(temp, Boton_alt)
	temp.sobre = false
	temp.width = 32
	temp.height = 32
	temp.x = x
	temp.y = y
	temp.imagen = imagenes["boton_alt_img"]
	return temp
end

function Boton_alt:draw()

if visible == true then
	if tiempoC >= 8 then
		love.graphics.draw(self.imagen, self.x, self.y)
	end
end

	if self.sobre then
		self.imagen = imagenes["boton_alt_imgB"]
	else
		self.imagen = imagenes["boton_alt_img"]
	end
end


function Boton_alt:update(dt)

	self.sobre = false

	local x = love.mouse.getX()
	local y = love.mouse.getY()

if visible == true then
	if tiempoC >= 8 then
		if x > self.x
			and x < self.x + self.width
			and y > self.y
			and y < self.y + self.height then
				self.sobre = true
			end
		end
	end
end

function  Boton_alt:mousereleased(x, y, button)
	if self.sobre then
	return true
	end
	return false
end

--Botn Next

Boton_next = {}
Boton_next.__index = Boton_next

function Boton_next.crear(x,y)

	local temp = {}
	setmetatable(temp, Boton_next)
	temp.sobre = false
	temp.width = 104
	temp.height = 74
	temp.x = x
	temp.y = y
	temp.imagen = imagenes["boton_next_img"]
	return temp
end

function Boton_next:draw()
	if visible == false then
		love.graphics.draw(self.imagen, self.x, self.y)
	end


	if self.sobre then
		self.imagen = imagenes["boton_next_imgB"]
	else
		self.imagen = imagenes["boton_next_img"]
	end


end

function Boton_next:update(dt)

	self.sobre = false

	local x = love.mouse.getX()
	local y = love.mouse.getY()

if visible == false then
	if x > self.x
		and x < self.x + self.width
		and y > self.y
		and y < self.y + self.height then
			self.sobre = true
		end
	end
end

function  Boton_next:mousereleased(x, y, button)
	if self.sobre then
	return true
	end
	return false
end

--Botn Replay

Boton_re = {}
Boton_re.__index = Boton_re

function Boton_re.crear(x, y)

	local temp = {}
	setmetatable(temp, Boton_re)
	temp.sobre = false
	temp.width = 295
	temp.height = 84
	temp.x = x
	temp.y = y
	temp.imagen = imagenes["boton_re_img"]
	return temp
end

function Boton_re:draw()

	love.graphics.draw(self.imagen, self.x, self.y)

	if self.sobre then self.imagen = imagenes["boton_re_imgB"]
	else self.imagen = imagenes["boton_re_img"]
	end
end

function Boton_re:update(dt)

	self.sobre = false

	local x = love.mouse.getX()
	local y = love.mouse.getY()

	if x > self.x
		and x < self.x + self.width
		and y > self.y
		and y < self.y + self.height then
		self.sobre = true
	end
end

function  Boton_re:mousereleased(x, y, button)
	if self.sobre then
	return true
	end
	return false
end

--Botn Volver

Boton_volver = {}
Boton_volver.__index = Boton_volver

function Boton_volver.crear(x,y)

	local temp = {}
	setmetatable(temp, Boton_volver)
	temp.sobre = false
	temp.width = 307
	temp.height = 97
	temp.x = x
	temp.y = y
	temp.imagen = imagenes["boton_volver_img"]
	return temp
end

function Boton_volver:draw()

	love.graphics.draw(self.imagen, self.x, self.y)

	if self.sobre then self.imagen = imagenes["boton_volver_imgB"]
	else self.imagen = imagenes["boton_volver_img"]
	end
end

function Boton_volver:update(dt)

	self.sobre = false

	local x = love.mouse.getX()
	local y = love.mouse.getY()

	if x > self.x
		and x < self.x + self.width
		and y > self.y
		and y < self.y + self.height then
		self.sobre = true
	end
end

function  Boton_volver:mousereleased(x, y, button)
	if self.sobre then
	return true
	end
	return false
end

--Botn escape

Boton_escape = {}
Boton_escape.__index = Boton_escape

function Boton_escape.crear(x,y)

	local temp = {}
	setmetatable(temp, Boton_escape)
	temp.sobre = false
	temp.width = 16
	temp.height = 16
	temp.x = x
	temp.y = y
	temp.imagen = imagenes["escape_img"]
	return temp
end

function Boton_escape:draw()

	love.graphics.draw(self.imagen, self.x, self.y)
end

function Boton_escape:update(dt)

	self.sobre = false

	local x = love.mouse.getX()
	local y = love.mouse.getY()

	if x > self.x
		and x < self.x + self.width
		and y > self.y
		and y < self.y + self.height then
		self.sobre = true
	end
end

function  Boton_escape:mousereleased(x, y, button)
	if self.sobre then
	return true
	end
	return false
end
