
-- (C)Chilean Challenge v1.0
-- Carlos Valderas & Valentina Bonilla, 2010
-- Licence: ZLIB

--------------

--Logo

Logo = {}
Logo.__index = Logo

function Logo.crear()
	local temp = {}
	setmetatable(temp, Logo)
	tiempoLogo = 0
	return temp
end

function Logo:draw()
	love.graphics.draw(imagenes["espiraculo"], 270, 150)
	love.graphics.draw(imagenes["logoEspiraculo"], 195, 500)
end

function Logo:update(dt)
	tiempoLogo = tiempoLogo + dt
	if tiempoLogo >= 5 then
		etapa = Menu.crear()
	end
end

function Logo:mousereleased(x,y,button)

end

function Logo:keypressed(key)
	if key == "escape" then
		love.event.push("q")
	end
end

--Men inicial

Menu = {}
Menu.__index = Menu

function Menu.crear()
	local temp = {}
	setmetatable(temp, Menu)
	temp.boton = {	btn1 = Boton_jugar.crear(80, 400),
					btn2 = Boton_instrucciones.crear(430, 400),
					btnesc = Boton_escape.crear(775, 3)}
	return temp
end

function Menu:draw()
	love.graphics.draw(imagenes["logo"], 130, 100)
	love.graphics.setFont(fuentes["tekton_fuente_creditos"])
	love.graphics.print("(C) Carlos Valderas & Valentina Bonilla, 2010.\nLicencia ZLIB", 5, 565)
	for n,b in pairs(self.boton) do
		b:draw()
	end

end

function Menu:update(dt)
	for n,b in pairs(self.boton) do
		b:update(dt)
	end
end

function Menu:mousereleased(x,y,button)
	for n,b in pairs(self.boton) do
		if b:mousereleased(x,y,button) then
			if n == "btn1" then
				etapa = Juego.crear()
			end
			if n == "btn2" then
				etapa = Instrucciones.crear()
			end
			if n == "btnesc" then
				love.event.push("q")
			end
		end
	end
end

function Menu:keypressed(key)
	if key == "escape" then
		love.event.push("q")
	end
end

--instrucciones

Instrucciones = {}
Instrucciones.__index = Instrucciones

function Instrucciones.crear()

	local temp = {}
	setmetatable(temp, Instrucciones)
	temp.boton = {	btn = Boton_volver.crear(480, 460),
					btnesc = Boton_escape.crear(775, 3)}
	return temp
end

function Instrucciones:draw()
	love.graphics.draw(imagenes["instrucciones"], 190, 30)
	love.graphics.draw(imagenes["fondo"], 35, 140)
	love.graphics.draw(imagenes["tema_1"], 500, 155)
	love.graphics.draw(imagenes["tema_2"], 500, 205)
	love.graphics.draw(imagenes["tema_3"], 500, 255)
	love.graphics.draw(imagenes["boton_alt_img"], 580, 300)
	love.graphics.draw(imagenes["boton_next_img"], 550, 350)
	love.graphics.setFont(fuentes["tekton3"])
	love.graphics.print("Completa las oraciones segn la categora\nque aparezca en la parte superior izquierda\ndel cuadro de pregunta.", 55, 175)
	love.graphics.print("Para seleccionar una de las alternativas, haz clic en", 55, 330)
	love.graphics.print("Para pasar a la siguiente pregunta, haz clic en", 55, 395)
	love.graphics.print("Tu puntaje depender de qu tan\nrpido aciertes, Buena Suerte!", 85, 480)
	for n,b in pairs(self.boton) do
		b:draw()
	end

end

function Instrucciones:update(dt)
	for n,b in pairs(self.boton) do
		b:update(dt)
	end
end

function Instrucciones:mousereleased(x,y,button)
	for n,b in pairs(self.boton) do
		if b:mousereleased(x,y,button) then
			if n == "btn" then
				etapa = Menu.crear()
			end
			if n == "btnesc" then
				love.event.push("q")
			end
		end
	end
end

function Instrucciones:keypressed(key)
	if key == "escape" then
		etapa = Menu.crear()
	end
end


--juego

Juego = {}
Juego.__index = Juego

function Juego.crear()

	local temp = {}
	setmetatable(temp, Juego)
	Obtener_pregunta.crear()
	temp.boton = {	altA = Boton_alt.crear(55, 285),
					altB = Boton_alt.crear(55, 345),
					altC = Boton_alt.crear(55, 405),
					altD = Boton_alt.crear(55, 465),
					bNext = Boton_next.crear(630, 470),
					btnesc = Boton_escape.crear(780, 3)}
	pA = 1
	visible = true
	puntaje = 0
	tiempo = 10
	tiempoB = 11
	tiempoC = 0
	tiempoControl = true
	control_alt = 0
	return temp
end

function Juego:draw()
	love.graphics.draw(imagenes["tablero"], 0, 0)
	love.graphics.draw(imagenes["fondo"], 35, 140)
	if visible == false then
		if control_alt == 0 then
			if preguntas_hechas[pA][7] == 1 then
				love.graphics.draw(imagenes["correcta_img"], 300, 275)
			end
			if preguntas_hechas[pA][7] == 2 then
				love.graphics.draw(imagenes["correcta_img"], 300, 335)
			end
			if preguntas_hechas[pA][7] == 3 then
				love.graphics.draw(imagenes["correcta_img"], 300, 395)
			end
			if preguntas_hechas[pA][7] == 4 then
				love.graphics.draw(imagenes["correcta_img"], 300, 455)
			end
		end
		if control_alt == 1 then
			if preguntas_hechas[pA][7] == 1 then
				love.graphics.draw(imagenes["correcta_img"], 300, 275)
			end
			if preguntas_hechas[pA][7] == 2 then
				love.graphics.draw(imagenes["incorrecta_img"], 300, 275)
				love.graphics.draw(imagenes["correcta_img"], 300, 335)
			end
			if preguntas_hechas[pA][7] == 3 then
				love.graphics.draw(imagenes["incorrecta_img"], 300, 275)
				love.graphics.draw(imagenes["correcta_img"], 300, 395)
			end
			if preguntas_hechas[pA][7] == 4 then
				love.graphics.draw(imagenes["incorrecta_img"], 300, 275)
				love.graphics.draw(imagenes["correcta_img"], 300, 455)
			end
		end
		if control_alt == 2 then
			if preguntas_hechas[pA][7] == 1 then
				love.graphics.draw(imagenes["incorrecta_img"], 300, 335)
				love.graphics.draw(imagenes["correcta_img"], 300, 275)
			end
			if preguntas_hechas[pA][7] == 2 then
				love.graphics.draw(imagenes["correcta_img"], 300, 335)
			end
			if preguntas_hechas[pA][7] == 3 then
				love.graphics.draw(imagenes["incorrecta_img"], 300, 335)
				love.graphics.draw(imagenes["correcta_img"], 300, 395)
			end
			if preguntas_hechas[pA][7] == 4 then
				love.graphics.draw(imagenes["incorrecta_img"], 300, 335)
				love.graphics.draw(imagenes["correcta_img"], 300, 455)
			end
		end
		if control_alt == 3 then
			if preguntas_hechas[pA][7] == 1 then
				love.graphics.draw(imagenes["incorrecta_img"], 300, 395)
				love.graphics.draw(imagenes["correcta_img"], 300, 275)
			end
			if preguntas_hechas[pA][7] == 2 then
				love.graphics.draw(imagenes["incorrecta_img"], 300, 395)
				love.graphics.draw(imagenes["correcta_img"], 300, 335)
			end
			if preguntas_hechas[pA][7] == 3 then
				love.graphics.draw(imagenes["correcta_img"], 300, 395)
			end
			if preguntas_hechas[pA][7] == 4 then
				love.graphics.draw(imagenes["incorrecta_img"], 300, 395)
				love.graphics.draw(imagenes["correcta_img"], 300, 455)
			end
		end
		if control_alt == 4 then
			if preguntas_hechas[pA][7] == 1 then
				love.graphics.draw(imagenes["incorrecta_img"], 300, 455)
				love.graphics.draw(imagenes["correcta_img"], 300, 275)
			end
			if preguntas_hechas[pA][7] == 2 then
				love.graphics.draw(imagenes["incorrecta_img"], 300, 455)
				love.graphics.draw(imagenes["correcta_img"], 300, 335)
			end
			if preguntas_hechas[pA][7] == 3 then
				love.graphics.draw(imagenes["incorrecta_img"], 300, 455)
				love.graphics.draw(imagenes["correcta_img"], 300, 395)
			end
			if preguntas_hechas[pA][7] == 4 then
				love.graphics.draw(imagenes["correcta_img"], 300, 455)
			end
		end
		if preguntas_hechas[pA][7] == 1 then
		love.graphics.setFont(fuentes["tekton3"])
		love.graphics.print(preguntas_hechas[pA][6], 400, 310)
		end
		if preguntas_hechas[pA][7] == 2 then
		love.graphics.setFont(fuentes["tekton3"])
		love.graphics.print(preguntas_hechas[pA][6], 400, 370)
		end
		if preguntas_hechas[pA][7] == 3 then
		love.graphics.setFont(fuentes["tekton3"])
		love.graphics.print(preguntas_hechas[pA][6], 400, 430)
		end
		if preguntas_hechas[pA][7] == 4 then
		love.graphics.setFont(fuentes["tekton3"])
		love.graphics.print(preguntas_hechas[pA][6], 400, 490)
		end
	end
	if pA <= 5 then
		love.graphics.setFont(fuentes["tekton2"])
		love.graphics.print(pA,235,60)
		love.graphics.print(puntaje, 486, 60)
		love.graphics.print(tiempo, 733, 60)
		love.graphics.setFont(fuentes["tekton"])
		if tiempoC >= 1 then
			love.graphics.print(preguntas_hechas[pA][5], 60, 230)
			if preguntas_hechas[pA][8] == 1 then
				love.graphics.draw(imagenes["tema_1"], 60, 155)
			end
			if preguntas_hechas[pA][8] == 2 then
				love.graphics.draw(imagenes["tema_2"], 60, 155)
			end
			if preguntas_hechas[pA][8] == 3 then
				love.graphics.draw(imagenes["tema_3"], 60, 155)
			end
		end
		if tiempoC >= 2.5 then
			love.graphics.print(preguntas_hechas[pA][1], 100, 310)
		end
		if tiempoC >= 4 then
			love.graphics.print(preguntas_hechas[pA][2], 100, 370)
		end
		if tiempoC >= 5.5 then
			love.graphics.print(preguntas_hechas[pA][3], 100, 430)
		end
		if tiempoC >= 7 then
			love.graphics.print(preguntas_hechas[pA][4], 100, 490)
		end
	end
	for n,b in pairs(self.boton) do
		b:draw()
	end
end

function Juego:update(dt)

--reloj

tiempoC = tiempoC + dt

if tiempoC >= 8 then
	if tiempoControl == true then
		tiempoB = tiempoB - dt
		if tiempoB >= 10 then
				tiempo = 10
		end
		if tiempoB >= 9 then
			if tiempoB < 10 then
				tiempo = 9
			end
		end
		if tiempoB >= 8 then
			if tiempoB < 9 then
				tiempo = 8
			end
		end
		if tiempoB >= 7 then
			if tiempoB < 8 then
				tiempo = 7
			end
		end
		if tiempoB >= 6 then
			if tiempoB < 7 then
				tiempo = 6
			end
		end
		if tiempoB >= 5 then
			if tiempoB < 6 then
				tiempo = 5
			end
		end
		if tiempoB >= 4 then
			if tiempoB < 5 then
				tiempo = 4
			end
		end
		if tiempoB >= 3 then
			if tiempoB < 4 then
				tiempo = 3
			end
		end
		if tiempoB >= 2 then
			if tiempoB < 3 then
				tiempo = 2
			end
		end
		if tiempoB >= 1 then
			if tiempoB < 2 then
				tiempo = 1
			end
		end
		if tiempoB >= 0 then
			if tiempoB < 1 then
				tiempo = 0
			end
		end
		if tiempo == 0 then
			control_alt = 0
			if visible == true then
				visible = false
			end
		end
	end
end
--fin del reloj

for n,b in pairs(self.boton) do
		b:update(dt)
	end
end

function Juego:mousereleased(x,y,button)


	for n,b in pairs(self.boton) do
		if b:mousereleased(x,y,button) then
				if n == "btnesc" then
				love.event.push("q")
				end
				if n == "altA" then
				tiempoControl = false
				control_alt = 1
				if preguntas_hechas[pA][7] == 1 then
					puntaje = puntaje + (tiempo*10)
				end
				if visible == true then
					visible = false
				end
			elseif n == "altB" then
				tiempoControl = false
				control_alt = 2
				if preguntas_hechas[pA][7] == 2 then
					puntaje = puntaje + (tiempo*10)
				end
				if visible == true then
					visible = false
				end
			elseif n == "altC" then
				tiempoControl = false
				control_alt = 3
				if preguntas_hechas[pA][7] == 3 then
					puntaje = puntaje + (tiempo*10)
				end
				if visible == true then
					visible = false
				end
			elseif n == "altD" then
				tiempoControl = false
				control_alt = 4
				if preguntas_hechas[pA][7] == 4 then
					puntaje = puntaje + (tiempo*10)
				end
				if visible == true then
					visible = false
				end
			elseif n == "bNext" then
				if pA < 5 then
					Obtener_pregunta.crear()
					pA = pA + 1
					tiempo = 10
					tiempoB = 11
					tiempoC = 0
					tiempoControl = true
					if visible == false then
						visible = true
					end
				else 	table.insert(puntaje_final,1,puntaje)
						Obtener_pregunta.devolver()
						etapa = Final.crear()
				end
			end
		end
	end
end

function Juego:keypressed(key)
	if key == "escape" then
		Obtener_pregunta.devolver()
		etapa = Menu.crear()
	end
end

--Final

Final = {}
Final.__index = Final

function Final.crear()

	local temp = {}
	setmetatable(temp, Final)
	temp.boton = {	btn = Boton_re.crear(430, 470),
					btnesc = Boton_escape.crear(775, 3)}
	return temp
end

function Final:draw()
	love.graphics.draw(imagenes["game_over"],230,100)
	love.graphics.setFont(fuentes["tekton_puntaje_final"])
	love.graphics.print("TU PUNTAJE FINAL ES " .. puntaje_final[1], 210, 230)
	if puntaje_final[1] >= 450 then
		love.graphics.draw(imagenes["puntaje_A_img"], 90, 260)
		love.graphics.setFont(fuentes["tekton2"])
		love.graphics.print("'Tocado por Chuck Norris'", 350, 320)
		love.graphics.setFont(fuentes["tekton3"])
		love.graphics.print("No slo pareces conocer\nchilenismos, sino que tambin\nel lenguaje del Universo.", 350, 355)
		love.graphics.setFont(fuentes["tekton_fuente_img"])
		love.graphics.print("Foto por pieter[iamdoom/bwrah bwrah]\nflickr.com/rrrr030", 5, 580)
	end
	if puntaje_final[1] >= 350 then
		if puntaje_final[1] < 450 then
			love.graphics.draw(imagenes["puntaje_B_img"], 90, 260)
			love.graphics.setFont(fuentes["tekton2"])
			love.graphics.print("'Ms chileno que los porotos'", 370, 320)
			love.graphics.setFont(fuentes["tekton3"])
			love.graphics.print("Eres tan chileno que tu rostro debera\nsalir en las monedas de 100 pesos.", 370, 355)
			love.graphics.setFont(fuentes["tekton_fuente_img"])
			love.graphics.print("Foto por Jaime Teran\nflickr.com/imacniatic", 5, 580)
		end
	end
	if puntaje_final[1] >= 150 then
		if puntaje_final[1] < 350 then
			love.graphics.draw(imagenes["puntaje_C_img"], 90, 260)
			love.graphics.setFont(fuentes["tekton2"])
			love.graphics.print("'Ni chicha ni limonada'\n", 330, 320)
			love.graphics.setFont(fuentes["tekton3"])
			love.graphics.print("Ests en el lmite, as que sal a la calle,\npara las churejas y a estudiar.", 330, 355)
			love.graphics.setFont(fuentes["tekton_fuente_img"])
			love.graphics.print("Foto por floodkoff\nflickr.com/floodkoff", 5, 580)
		end
	end
	if puntaje_final[1] < 150 then
			love.graphics.draw(imagenes["puntaje_D_img"], 90, 260)
			love.graphics.setFont(fuentes["tekton2"])
			love.graphics.print("'Ms perdido que el teniente Bello'", 330, 320)
			love.graphics.setFont(fuentes["tekton3"])
			love.graphics.print("Usted no tiene idea de donde est\nparado, parece turista.", 330, 355)
			love.graphics.setFont(fuentes["tekton_fuente_img"])
			love.graphics.print("Fotografa por Don Solo\nflirck.com/donsolo", 5, 580)

	end
	for n,b in pairs(self.boton) do
		b:draw()
	end
end

function Final:update(dt)
	for n,b in pairs(self.boton) do
		b:update(dt)
	end
end

function Final:mousereleased(x,y,button)
	for n,b in pairs(self.boton) do
		if b:mousereleased(x,y,button) then
			if n == "btn" then
				etapa = Menu.crear()
			end
			if n == "btnesc" then
				love.event.push("q")
			end
		end
	end
end

function Final:keypressed(key)
	if key == "escape" then
		etapa = Menu.crear()
	end
end
